# A guide to ExpansionHunter Denovo software

ExpansionHunter Denovo (EHdn) is a suite of tools for detecting novel expansions
of short tandem repeats (STRs). EHdn is intended for analysis of a collection of
BAM/CRAM files containing alignments of short (100-200bp) reads.

To use ExpansionHunter Denovo you need to (1) download the latest release or build
the program from source, (2) obtain a collection of BAM/CRAM files a subset of which
is suspected to contain a repeat expansion.

The following sections will help you to get started.

Quick start guides:

- [Before you begin](01_Before_you_begin.md)
- [Installation](02_Installation.md)
- [Case-control analysis](03_Case_control_quickstart.md)
- [Outlier analysis](04_Outlier_quickstart.md)

Manual pages:

- [Computing STR profiles](05_Computing_profiles.md)
- [Merging single-sample STR profiles into multisample profiles](06_Merging_profiles.md)
- [Performing case control analysis](07_Case_control_analysis.md)
- [Annotating locus analysis results](08_Annotation.md)
- [Repeat Prioritization Strategies](09_Repeat_prioritization_strategies.md)
